<?php

// Survey database interface class as intermediate for storing data from the site to the RDF database 
require_once 'rdfConstants.php';

// Include RAP Library to write RDF files
include(RDFAPI_INCLUDE_DIR . "RDFAPI.php");



class ApplicationDatabaseInterface
{		
    protected $applicationRDFWriter;
    protected $applicationRDFReader;

    protected $applicationID;


    public function __construct($applicationID)
    {		
        if($applicationID == null)
            $this->applicationID = md5( uniqid(rand(), true) );
        else
            $this->applicationID = $applicationID;
			
        $this->applicationRDFWriter = new ApplicationRDFWriter($this->applicationID);
        $this->applicationRDFReader = new ApplicationRDFReader();
    }
    
    public function getApplicationID()
    {
        return $this->applicationID;
    }

    public function setApplicationInfo($applicationInfo)
    {
        $appTitle = $applicationInfo['applicationTitle'];
        $appDescription = $applicationInfo['applicationDescription'];
        $appStyle = null;

        $this->applicationRDFWriter->setApplicationInfo($appTitle, $appDescription, $appStyle);

        $this->applicationRDFWriter->saveApplications();
    }

    public function getApplicationInfo($applicationID)
    {
        $applicationInfo = array();

        $resultApplication = $this->applicationRDFReader->readApplicationInfo($applicationID);

        $applicationInfo['applicationID'] = substr($resultApplication['?uid'],9,strlen($resultApplication['?uid'])-11);
        $applicationInfo['applicationTitle'] = substr($resultApplication['?title'],9,strlen($resultApplication['?title'])-11);
        $applicationInfo['applicationDescription'] = substr($resultApplication['?description'],9,strlen($resultApplication['?description'])-11);
        $applicationInfo['applicationStyle'] = substr($resultApplication['?style'],9,strlen($resultApplication['?style'])-11);

        return $applicationInfo;
    }

    public function getExistingApplications()
    {
        $applicationInfo = array();

        $resultApplication = $this->applicationRDFReader->readAllApplications();
        
        for($aNumber = 0;$aNumber<sizeof($resultApplication[0]);$aNumber++)
        {
            $aID = substr($resultApplication[0][$aNumber]['?uid'],9,strlen($resultApplication[0][$aNumber]['?uid'])-11);
            $aTitle = substr($resultApplication[1][$aNumber]['?title'],9,strlen($resultApplication[1][$aNumber]['?title'])-11);
            $applicationInfo[$aID] = $aTitle;
        }		

        return $applicationInfo;
    }
}
?>